# Exercises - Intro to Text Mining
import nltk
# I had to download this from the cli
#nltk.download()
from nltk.book import *

#%%
'''
Question 1:

Find information about texts. List the materials in texts and sentences. 
'''

# Answer

texts()
sents()

#%%
'''
Question 2:

Try searching for words using the concordance command. 
Search Sense and Sensibility for the word affection.
Search the book of Genesis to find out how long some people lived.
'''

# Answer

text2.concordance("affection")
text3.concordance("lived")

#%%
'''
Question 3:

Pick a pair of words and compare their usage in two different texts.
Use the similar() and common_contexts() functions.

What is the main difference between the two functions?
'''
# Answer

# The main difference is that common_contexts allows you to use two or more words that
# share the same context. 

# text4.concordance("great") - making sure this is within text 4

text4.similar("great")
# new whole the just large free national general same vast important
# high highest that present first united our supreme true

text4.common_contexts(["supreme", "great"])
# the_author of_importance the_law a_and the_purpose
#%%
'''
Question 4:
 Produce a dispersion plot of the four main protagonists in Sense and Sensibility: Elinor, Marianne, Edward, and Willoughby. 
 What can you observe about the different roles played by the males and females in this novel? 
 Can you identify the couples?
'''

# Answer

texts()
# text 2 = Sense and Sensibility

text2.dispersion_plot(["Elinor", "Marianne", "Edward", "Willoughby"])

# Females are much more prevalent throughout the book. It looks like Marianne and Edward are a couple
# just based off the fact that Willoughby and Marianne are mentioned at disparate times.

#%%
'''
Question 5:
    
Find the collocations in text5.
'''
# Answer

text5.collocations()
# wanna chat; PART JOIN; MODE #14-19teens; JOIN PART; PART PART;
# cute.-ass MP3; MP3 player; JOIN JOIN; times .. .; ACTION watches; guys
# wanna; song lasts; last night; ACTION sits; -...)...- S.M.R.; Lime
# Player; Player 12%; dont know; lez gurls; long time

#%%
'''
Question 6:
Consider the following Python expression: len(set(text4)). 
State the purpose of this expression. Describe the two steps involved in performing this computation.  

'''

# Answer

# 9754 = len(set(text4))
# len gets the total number of words in text 4, set finds the total number of distinct words. 

#%%
'''
Question 7:
    
The first sentence of text3 is provided to you in the variable sent3. 
The index of the in sent3 is 1, because sent3[1] gives us 'the'. 
What are the indexes of the two other occurrences of this word in sent3?
'''
# Answer

sent3
# sent3 = ['In', 'the', 'beginning', 'God', 'created', 'the', 'heaven', 'and', 'the', 'earth', '.']
indices = [i for i, x in enumerate(sent3) if x == "the"]
print(indices)

#%%
'''
Question 8:
Using conditonals, find all words in the Chat Corpus (text5) starting with the letter b. 
Show them in alphabetical order.
'''

# Answer 

start_with_b = [w for w in text5 if w.startswith('b')]
print(sorted(start_with_b))

#%%
'''
Question 9:

Using list addition, and the set and sorted operations, 
compute the vocabulary of the sentences sent1 ... sent8.
'''
# Answer

print(sorted(set(sent1+sent2+sent3+sent4+sent5+sent6+sent7+sent8)))

#%%
'''
Question 10:
Find all the four-letter words in the Chat Corpus (text5).
With the help of a frequency distribution (FreqDist), show these words in decreasing order of frequency.    

'''

# Answer

four_letter_words = sorted([w.lower() for w in text5 if len(w) is 4])
FreqDist(four_letter_words)

#%%
'''
Question 11:
Review the discussion of looping with conditions in 4. 
Use a combination of for and if statements to loop over the words of the movie script for 
Monty Python and the Holy Grail (text6) and print all the uppercase words, one per line.

'''

# Answer

texts()
# text6: Monty Python and the Holy Grail

upper_case_words = [w for w in text6 if w.isupper()]
for word in upper_case_words:
    print(word)

#%%
'''
Question 12:
Define a function percent(word, text) that calculates how often a 
given word occurs in a text, and expresses the result as a percentage.
'''

# Answer

def percent(word,text):
    percent = text.count(word)/len(text)
    return percent



# importing all necessary libraries for the exercises below
import nltk
from nltk.corpus import wordnet as wn
import nltk
from nltk.corpus import *
from nltk.corpus import state_union
from matplotlib import pylab

#%%

'''
Question 13:

Create a variable phrase containing a list of words. 
Review the operations described in the previous chapter, including addition, multiplication, indexing, slicing, and sorting.
'''

# Answer
sent = "We are having a great time and becoming Python pros!"
phrase = sent.split()
phrase.append('extra words') #addition
for w in phrase:
   p(phrase.index(w)) #indexing
p(phrase*2) #multiplication
p(phrase[2:5]) #slicing
p(sorted(map(lambda x: x.lower(),phrase)))

#%%

'''
Question 14:

Use the corpus module to explore austen-persuasion.txt. How many word tokens does this book have? How many word types?
'''

# Answer:
austen = gutenberg.words('austen-persuasion.txt')
p(len(map(lambda x: x.lower(),austen)))
p(len(set(map(lambda x: x.lower(),austen))))

#%%


'''
Question 15:

 Define a conditional frequency distribution over the Names corpus that allows you to 
 see which initial letters are more frequent for males vs. females 
'''

# Answer:

cfd = nltk.ConditionalFreqDist(
    (fileid, name[0])
    for fileid in names.fileids()
    for name in names.words(fileid))
cfd.plot()